Index: /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_3/limthd_lac.F90
===================================================================
--- /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_3/limthd_lac.F90	(revision 3516)
+++ /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_3/limthd_lac.F90	(revision 3517)
@@ -143,9 +143,9 @@
       ! 1) Conservation check and changes in each ice category
       !------------------------------------------------------------------------------!
-      IF ( con_i ) THEN
-         CALL lim_column_sum (jpl, v_i, vt_i_init)
-         CALL lim_column_sum (jpl, v_s, vt_s_init)
-         CALL lim_column_sum_energy (jpl, nlay_i, e_i, et_i_init)
-         CALL lim_column_sum (jpl,   e_s(:,:,1,:) , et_s_init)
+      IF( con_i ) THEN
+         CALL lim_column_sum        ( jpl, v_i          , vt_i_init)
+         CALL lim_column_sum        ( jpl, v_s          , vt_s_init)
+         CALL lim_column_sum_energy ( jpl, nlay_i , e_i , et_i_init)
+         CALL lim_column_sum        ( jpl, e_s(:,:,1,:) , et_s_init)
       ENDIF
 
@@ -158,9 +158,7 @@
                DO ji = 1, jpi
                   !Energy of melting q(S,T) [J.m-3]
-                  e_i(ji,jj,jk,jl) = e_i(ji,jj,jk,jl) / &
-                     MAX( area(ji,jj) * v_i(ji,jj,jl) ,  epsi10 ) * &
-                     nlay_i
-                  zindb      = 1.0-MAX(0.0,SIGN(1.0,-v_i(ji,jj,jl))) !0 if no ice and 1 if yes
-                  e_i(ji,jj,jk,jl) = e_i(ji,jj,jk,jl)*unit_fac*zindb
+                  e_i(ji,jj,jk,jl) = e_i(ji,jj,jk,jl) / MAX( area(ji,jj) * v_i(ji,jj,jl) ,  epsi10 ) * nlay_i
+                  zindb = 1._wp - MAX(  0._wp , SIGN( 1._wp , -v_i(ji,jj,jl) )  )   !0 if no ice and 1 if yes
+                  e_i(ji,jj,jk,jl) = e_i(ji,jj,jk,jl) * unit_fac * zindb
                END DO
             END DO
@@ -182,19 +180,15 @@
       ! 
 
-      zvrel(:,:) = 0.0
+      zvrel(:,:) = 0._wp
 
       ! Default new ice thickness 
-      DO jj = 1, jpj
-         DO ji = 1, jpi
-            hicol(ji,jj) = hiccrit(1)
-         END DO
-      END DO
-
-      IF (fraz_swi.eq.1.0) THEN
+      hicol(:,:) = hiccrit(1)
+
+      IF( fraz_swi == 1._wp ) THEN
 
          !--------------------
          ! Physical constants
          !--------------------
-         hicol(:,:) = 0.0
+         hicol(:,:) = 0._wp
 
          zhicrit = 0.04 ! frazil ice thickness
@@ -306,33 +300,21 @@
       IF ( nbpac > 0 ) THEN
 
-         CALL tab_2d_1d( nbpac, zat_i_ac  (1:nbpac)     , at_i         ,       &
-            jpi, jpj, npac(1:nbpac) )
+         CALL tab_2d_1d( nbpac, zat_i_ac  (1:nbpac)     , at_i         , jpi, jpj, npac(1:nbpac) )
          DO jl = 1, jpl
-            CALL tab_2d_1d( nbpac, za_i_ac(1:nbpac,jl)  , a_i(:,:,jl)  ,       &
-               jpi, jpj, npac(1:nbpac) )
-            CALL tab_2d_1d( nbpac, zv_i_ac(1:nbpac,jl)  , v_i(:,:,jl)  ,       &
-               jpi, jpj, npac(1:nbpac) )
-            CALL tab_2d_1d( nbpac, zoa_i_ac(1:nbpac,jl) , oa_i(:,:,jl) ,       &
-               jpi, jpj, npac(1:nbpac) )
-            CALL tab_2d_1d( nbpac, zsmv_i_ac(1:nbpac,jl), smv_i(:,:,jl),       &
-               jpi, jpj, npac(1:nbpac) )
+            CALL tab_2d_1d( nbpac, za_i_ac(1:nbpac,jl)  , a_i(:,:,jl)  , jpi, jpj, npac(1:nbpac) )
+            CALL tab_2d_1d( nbpac, zv_i_ac(1:nbpac,jl)  , v_i(:,:,jl)  , jpi, jpj, npac(1:nbpac) )
+            CALL tab_2d_1d( nbpac, zoa_i_ac(1:nbpac,jl) , oa_i(:,:,jl) , jpi, jpj, npac(1:nbpac) )
+            CALL tab_2d_1d( nbpac, zsmv_i_ac(1:nbpac,jl), smv_i(:,:,jl), jpi, jpj, npac(1:nbpac) )
             DO jk = 1, nlay_i
-               CALL tab_2d_1d( nbpac, ze_i_ac(1:nbpac,jk,jl), e_i(:,:,jk,jl) , &
-                  jpi, jpj, npac(1:nbpac) )
+               CALL tab_2d_1d( nbpac, ze_i_ac(1:nbpac,jk,jl), e_i(:,:,jk,jl) , jpi, jpj, npac(1:nbpac) )
             END DO ! jk
          END DO ! jl
 
-         CALL tab_2d_1d( nbpac, qldif_1d  (1:nbpac)     , qldif ,              &
-            jpi, jpj, npac(1:nbpac) )
-         CALL tab_2d_1d( nbpac, qcmif_1d  (1:nbpac)     , qcmif ,              &
-            jpi, jpj, npac(1:nbpac) )
-         CALL tab_2d_1d( nbpac, t_bo_b    (1:nbpac)     , t_bo  ,              &
-            jpi, jpj, npac(1:nbpac) )
-         CALL tab_2d_1d( nbpac, fseqv_1d  (1:nbpac)     , fseqv ,              &
-            jpi, jpj, npac(1:nbpac) )
-         CALL tab_2d_1d( nbpac, hicol_b   (1:nbpac)     , hicol ,              &
-            jpi, jpj, npac(1:nbpac) )
-         CALL tab_2d_1d( nbpac, zvrel_ac  (1:nbpac)     , zvrel ,              &
-            jpi, jpj, npac(1:nbpac) )
+         CALL tab_2d_1d( nbpac, qldif_1d  (1:nbpac)     , qldif , jpi, jpj, npac(1:nbpac) )
+         CALL tab_2d_1d( nbpac, qcmif_1d  (1:nbpac)     , qcmif , jpi, jpj, npac(1:nbpac) )
+         CALL tab_2d_1d( nbpac, t_bo_b    (1:nbpac)     , t_bo  , jpi, jpj, npac(1:nbpac) )
+         CALL tab_2d_1d( nbpac, fseqv_1d  (1:nbpac)     , fseqv , jpi, jpj, npac(1:nbpac) )
+         CALL tab_2d_1d( nbpac, hicol_b   (1:nbpac)     , hicol , jpi, jpj, npac(1:nbpac) )
+         CALL tab_2d_1d( nbpac, zvrel_ac  (1:nbpac)     , zvrel , jpi, jpj, npac(1:nbpac) )
 
          !------------------------------------------------------------------------------!
@@ -344,7 +326,7 @@
          !----------------------
          DO ji = 1, nbpac
-            zh_newice(ji)     = hiccrit(1)
-         END DO
-         IF ( fraz_swi .EQ. 1.0 ) zh_newice(:) = hicol_b(:)
+            zh_newice(ji) = hiccrit(1)
+         END DO
+         IF( fraz_swi == 1.0 )   zh_newice(:) = hicol_b(:)
 
          !----------------------
@@ -352,22 +334,17 @@
          !----------------------
 
-         IF ( num_sal .EQ. 1 ) THEN
-            zs_newice(:)      =   bulk_sal
-         ENDIF ! num_sal
-
-         IF ( ( num_sal .EQ. 2 ) .OR. ( num_sal .EQ. 4 ) ) THEN
-
-            DO ji = 1, nbpac
-               zs_newice(ji)  =   MIN( 4.606 + 0.91 / zh_newice(ji) , s_i_max )
-               zji            =   MOD( npac(ji) - 1, jpi ) + 1
-               zjj            =   ( npac(ji) - 1 ) / jpi + 1
-               zs_newice(ji)  =   MIN( 0.5*sss_m(zji,zjj) , zs_newice(ji) )
-            END DO ! jl
-
-         ENDIF ! num_sal
-
-         IF ( num_sal .EQ. 3 ) THEN
-            zs_newice(:)      =   2.3
-         ENDIF ! num_sal
+         SELECT CASE ( num_sal )
+         CASE ( 1 )                    ! Sice = constant 
+            zs_newice(:) = bulk_sal
+         CASE ( 2 )                    ! Sice = F(z,t) [Vancoppenolle et al (2005)]
+            DO ji = 1, nbpac
+               zji =   MOD( npac(ji) - 1 , jpi ) + 1
+               zjj =      ( npac(ji) - 1 ) / jpi + 1
+               zs_newice(ji) = MIN(  4.606 + 0.91 / zh_newice(ji) , s_i_max , 0.5 * sss_m(zji,zjj)  )
+            END DO
+         CASE ( 3 )                    ! Sice = F(z) [multiyear ice]
+            zs_newice(:) =   2.3
+         END SELECT
+
 
          !-------------------------
@@ -376,12 +353,10 @@
          ! We assume that new ice is formed at the seawater freezing point
          DO ji = 1, nbpac
-            ztmelts           = - tmut * zs_newice(ji) + rtt ! Melting point (K)
-            ze_newice(ji)     =   rhoic * ( cpic * ( ztmelts - t_bo_b(ji) )    &
-               + lfus * ( 1.0 - ( ztmelts - rtt )   &
-               / ( t_bo_b(ji) - rtt ) )           &
-               - rcp * ( ztmelts-rtt ) )
-            ze_newice(ji)     =   MAX( ze_newice(ji) , 0.0 ) +                 &
-               MAX( 0.0 , SIGN( 1.0 , - ze_newice(ji) ) )   & 
-               * rhoic * lfus
+            ztmelts       = - tmut * zs_newice(ji) + rtt                  ! Melting point (K)
+            ze_newice(ji) =   rhoic * (  cpic * ( ztmelts - t_bo_b(ji) )                             &
+               &                       + lfus * ( 1.0 - ( ztmelts - rtt ) / ( t_bo_b(ji) - rtt ) )   &
+               &                       - rcp  *         ( ztmelts - rtt )  )
+            ze_newice(ji) =   MAX( ze_newice(ji) , 0._wp )    &
+               &          +   MAX(  0.0 , SIGN( 1.0 , - ze_newice(ji) )  ) * rhoic * lfus
          END DO ! ji
          !----------------
@@ -389,5 +364,5 @@
          !----------------
          DO ji = 1, nbpac
-            zo_newice(ji)     = 0.0
+            zo_newice(ji) = 0._wp
          END DO ! ji
 
@@ -396,5 +371,5 @@
          !--------------------------
          DO ji = 1, nbpac
-            zqbgow(ji)        = qldif_1d(ji) - qcmif_1d(ji) !<0
+            zqbgow(ji) = qldif_1d(ji) - qcmif_1d(ji)     !<0
          END DO ! ji
 
@@ -403,10 +378,9 @@
          !-------------------
          DO ji = 1, nbpac
-            zv_newice(ji)     = - zqbgow(ji) / ze_newice(ji)
+            zv_newice(ji) = - zqbgow(ji) / ze_newice(ji)
 
             ! A fraction zfrazb of frazil ice is accreted at the ice bottom
-            zfrazb        = ( TANH ( Cfrazb * ( zvrel_ac(ji) - vfrazb ) )     & 
-               + 1.0 ) / 2.0 * maxfrazb
-            zdh_frazb(ji) = zfrazb*zv_newice(ji)
+            zfrazb        = ( TANH ( Cfrazb * ( zvrel_ac(ji) - vfrazb ) ) + 1.0 ) * 0.5 * maxfrazb
+            zdh_frazb(ji) =         zfrazb   * zv_newice(ji)
             zv_newice(ji) = ( 1.0 - zfrazb ) * zv_newice(ji)
          END DO
@@ -415,21 +389,8 @@
          ! Salt flux due to new ice growth
          !---------------------------------
-         IF ( ( num_sal .EQ. 4 ) ) THEN 
-            DO ji = 1, nbpac
-               zji            = MOD( npac(ji) - 1, jpi ) + 1
-               zjj            = ( npac(ji) - 1 ) / jpi + 1
-               fseqv_1d(ji)   = fseqv_1d(ji) +                                     &
-                  ( sss_m(zji,zjj) - bulk_sal      ) * rhoic *       &
-                  zv_newice(ji) / rdt_ice
-            END DO
-         ELSE
-            DO ji = 1, nbpac
-               zji            = MOD( npac(ji) - 1, jpi ) + 1
-               zjj            = ( npac(ji) - 1 ) / jpi + 1
-               fseqv_1d(ji)   = fseqv_1d(ji) +                                     &
-                  ( sss_m(zji,zjj) - zs_newice(ji) ) * rhoic *       &
-                  zv_newice(ji) / rdt_ice
-            END DO ! ji
-         ENDIF
+         ! note that for constant salinity zs_newice() = bulk_sal (see top of the subroutine)
+         DO ji = 1, nbpac
+            fseqv_1d(ji) = fseqv_1d(ji) - zs_newice(ji) * rhoic * zv_newice(ji) * r1_rdtice
+         END DO ! ji
 
          !------------------------------------
@@ -448,6 +409,5 @@
 
          ! keep new ice volume in memory
-         CALL tab_1d_2d( nbpac, v_newice , npac(1:nbpac), zv_newice(1:nbpac) , &
-            jpi, jpj )
+         CALL tab_1d_2d( nbpac, v_newice , npac(1:nbpac), zv_newice(1:nbpac) , jpi, jpj )
 
          !-----------------
@@ -459,5 +419,5 @@
             zji                  = MOD( npac(ji) - 1, jpi ) + 1
             zjj                  = ( npac(ji) - 1 ) / jpi + 1
-            diag_lat_gr(zji,zjj) = zv_newice(ji) / rdt_ice
+            diag_lat_gr(zji,zjj) = zv_newice(ji) * r1_rdtice
          END DO !ji
 
@@ -628,8 +588,8 @@
          ! Update salinity
          !-----------------
-         IF(  num_sal == 2  .OR.  num_sal == 4  ) THEN
+         IF(  num_sal == 2  ) THEN      ! Sice = F(z,t)
             DO jl = 1, jpl
                DO ji = 1, nbpac
-                  zindb = 1._wp - MAX( 0._wp , SIGN( 1._wp , - zv_i_ac(ji,jl) ) )  ! 0 if no ice and 1 if yes
+                  zindb = 1._wp - MAX( 0._wp , SIGN( 1._wp , - zv_i_ac(ji,jl) ) )   ! 0 if no ice and 1 if yes
                   zdv   = zv_i_ac(ji,jl) - zv_old(ji,jl)
                   zsmv_i_ac(ji,jl) = ( zsmv_i_ac(ji,jl) + zdv * zs_newice(ji) ) * zindb
@@ -645,5 +605,5 @@
             CALL tab_1d_2d( nbpac, v_i (:,:,jl), npac(1:nbpac), zv_i_ac (1:nbpac,jl), jpi, jpj )
             CALL tab_1d_2d( nbpac, oa_i(:,:,jl), npac(1:nbpac), zoa_i_ac(1:nbpac,jl), jpi, jpj )
-            IF (  num_sal == 2  .OR.  num_sal == 4  )   &
+            IF (  num_sal == 2  )   &
                CALL tab_1d_2d( nbpac, smv_i (:,:,jl), npac(1:nbpac), zsmv_i_ac(1:nbpac,jl) , jpi, jpj )
             DO jk = 1, nlay_i
Index: /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_3/limthd_sal.F90
===================================================================
--- /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_3/limthd_sal.F90	(revision 3516)
+++ /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_3/limthd_sal.F90	(revision 3517)
@@ -44,14 +44,12 @@
       !! ** Purpose :   computes new salinities in the ice
       !!
-      !! ** Method  :  4 possibilities
-      !!               -> num_sal = 1 -> constant salinity for z,t
-      !!               -> num_sal = 2 -> S = S(z,t) [simple Vancoppenolle et al 2005]
-      !!               -> num_sal = 3 -> S = S(z)   [multiyear ice]
-      !!               -> num_sal = 4 -> S = S(h)   [Cox and Weeks 74]
+      !! ** Method  :  3 possibilities
+      !!               -> num_sal = 1 -> Sice = cst    [ice salinity constant in both time & space] 
+      !!               -> num_sal = 2 -> Sice = S(z,t) [Vancoppenolle et al. 2005]
+      !!               -> num_sal = 3 -> Sice = S(z)   [multiyear ice]
       !!---------------------------------------------------------------------
-      INTEGER, INTENT(in) ::  kideb, kiut   ! thickness category index
+      INTEGER, INTENT(in) ::   kideb, kiut   ! thickness category index
       !
       INTEGER  ::   ji, jk     ! dummy loop indices 
-      INTEGER  ::   zji, zjj   ! local integers
       REAL(wp) ::   zsold, iflush, iaccrbo, igravdr, isnowic, i_ice_switch,  ztmelts   ! local scalars
       REAL(wp) ::   zaaa, zbbb, zccc, zdiscrim   ! local scalars
@@ -64,17 +62,10 @@
       ! 1) Constant salinity, constant in time                                       |
       !------------------------------------------------------------------------------|
-!!gm comment: if num_sal = 1 s_i_b and sm_i_b can be set to bulk_sal one for all in the initialisation phase !!
-      IF( num_sal == 1 ) THEN
-         !
-         DO jk = 1, nlay_i
-            DO ji = kideb, kiut
-               s_i_b(ji,jk) =  bulk_sal
-            END DO ! ji
-         END DO ! jk
-         !
-         DO ji = kideb, kiut
-            sm_i_b(ji)      =  bulk_sal 
-         END DO ! ji
-         !
+!!gm comment: if num_sal = 1 s_i_new, s_i_b and sm_i_b can be set to bulk_sal one for all in the initialisation phase !!
+!!gm           ===>>>   simplification of almost all test on num_sal value
+      IF(  num_sal == 1  ) THEN
+            s_i_b  (kideb:kiut,1:nlay_i) =  bulk_sal
+            sm_i_b (kideb:kiut)          =  bulk_sal 
+            s_i_new(kideb:kiut)          =  bulk_sal
       ENDIF
 
@@ -83,5 +74,5 @@
       !------------------------------------------------------------------------------|
 
-      IF(  num_sal == 2  .OR.  num_sal == 4  ) THEN
+      IF(  num_sal == 2  ) THEN
 
          !---------------------------------
@@ -118,5 +109,5 @@
             dsm_i_gd_1d(ji) = - igravdr * MAX( sm_i_b(ji) - sal_G , 0._wp ) / time_G * rdt_ice 
             !                                   ! drainage by flushing  
-            dsm_i_fl_1d(ji) = - iflush * MAX( sm_i_b(ji) - sal_F , 0._wp ) / time_F * rdt_ice
+            dsm_i_fl_1d(ji) = - iflush  * MAX( sm_i_b(ji) - sal_F , 0._wp ) / time_F * rdt_ice
 
             !-----------------
@@ -133,6 +124,6 @@
          END DO ! ji
 
-         ! Salinity profile
-         CALL lim_var_salprof1d( kideb, kiut )
+         CALL lim_var_salprof1d( kideb, kiut )         ! Salinity profile
+
 
          !----------------------------
@@ -143,9 +134,9 @@
 !!gm useless
             ! iflush  : 1 if summer 
-            iflush  =  MAX( 0._wp , SIGN ( 1._wp , t_su_b(ji) - rtt ) ) 
+            iflush  =  MAX( 0._wp , SIGN( 1._wp , t_su_b(ji) - rtt        )  ) 
             ! igravdr : 1 if t_su lt t_bo
-            igravdr =  MAX( 0._wp , SIGN ( 1._wp , t_bo_b(ji) - t_su_b(ji) ) ) 
+            igravdr =  MAX( 0._wp , SIGN( 1._wp , t_bo_b(ji) - t_su_b(ji) )  ) 
             ! iaccrbo : 1 if bottom accretion
-            iaccrbo =  MAX( 0._wp , SIGN ( 1._wp , dh_i_bott(ji) ) )
+            iaccrbo =  MAX( 0._wp , SIGN( 1._wp , dh_i_bott(ji)           )  )
 !!gm end useless
             !
@@ -157,8 +148,7 @@
          !----------------------------
          DO ji = kideb, kiut
-            i_ice_switch = 1._wp - MAX ( 0._wp, SIGN( 1._wp , - ht_i_b(ji) ) )
+            i_ice_switch = 1._wp - MAX(  0._wp, SIGN( 1._wp , - ht_i_b(ji) )  )
             fsbri_1d(ji) = fsbri_1d(ji) - i_ice_switch * rhoic * a_i_b(ji) * ht_i_b(ji)         &
-               &         * ( MAX(dsm_i_gd_1d(ji) + dsm_i_fl_1d(ji), sm_i_b(ji) - zsiold(ji) ) ) / rdt_ice
-            IF( num_sal == 4 ) fsbri_1d(ji) = 0._wp
+               &         * ( MAX(dsm_i_gd_1d(ji) + dsm_i_fl_1d(ji), sm_i_b(ji) - zsiold(ji) ) ) * r1_rdtice
          END DO ! ji
 
@@ -179,5 +169,5 @@
          END DO
          !
-      ENDIF ! num_sal .EQ. 2
+      ENDIF 
 
       !------------------------------------------------------------------------------|
@@ -185,49 +175,14 @@
       !------------------------------------------------------------------------------|
 
-      IF( num_sal == 3 )   CALL lim_var_salprof1d( kideb, kiut )
-
-      !------------------------------------------------------------------------------|
-      !  Module 4 : Constant salinity varying in time                                |
-      !------------------------------------------------------------------------------|
-
-      IF( num_sal == 5 ) THEN      ! Cox and Weeks, 1974
-         !
-         DO ji = kideb, kiut
-            zsold = sm_i_b(ji)
-            IF( ht_i_b(ji) < 0.4 ) THEN
-               sm_i_b(ji) = 14.24 - 19.39 * ht_i_b(ji) 
-            ELSE
-               sm_i_b(ji) =  7.88 - 1.59 * ht_i_b(ji)
-               sm_i_b(ji) = MIN( sm_i_b(ji) , zsold )  
-            ENDIF
-            IF( ht_i_b(ji) > 3.06918239 ) THEN 
-               sm_i_b(ji) = 3._wp
-            ENDIF
-            DO jk = 1, nlay_i
-               s_i_b(ji,jk)   = sm_i_b(ji)
-            END DO
-         END DO
-         !
-      ENDIF ! num_sal
+      IF(  num_sal == 3  )   CALL lim_var_salprof1d( kideb, kiut )
+
 
       !------------------------------------------------------------------------------|
       ! 5) Computation of salt flux due to Bottom growth
       !------------------------------------------------------------------------------|
-
-      IF ( num_sal == 4 ) THEN
-         DO ji = kideb, kiut
-            zji = MOD( npb(ji) - 1 , jpi ) + 1
-            zjj =    ( npb(ji) - 1 ) / jpi + 1
-            fseqv_1d(ji) = fseqv_1d(ji) + ( sss_m(zji,zjj) - bulk_sal    )               &
-               &                        * rhoic * a_i_b(ji) * MAX( dh_i_bott(ji) , 0.0 ) / rdt_ice
-         END DO
-      ELSE
-         DO ji = kideb, kiut
-            zji = MOD( npb(ji) - 1 , jpi ) + 1
-            zjj =    ( npb(ji) - 1 ) / jpi + 1
-            fseqv_1d(ji) = fseqv_1d(ji) + ( sss_m(zji,zjj) - s_i_new(ji) )               &
-               &                        * rhoic * a_i_b(ji) * MAX( dh_i_bott(ji) , 0.0 ) / rdt_ice
-         END DO
-      ENDIF
+      ! note: s_i_new = bulk_sal in constant salinity case
+      DO ji = kideb, kiut
+         fseqv_1d(ji) = fseqv_1d(ji) - s_i_new(ji) * rhoic * a_i_b(ji) * MAX( dh_i_bott(ji) , 0._wp ) * r1_rdtice
+      END DO
       !
       CALL wrk_dealloc( jpij, ze_init, zhiold, zsiold )
Index: /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_3/limtrp.F90
===================================================================
--- /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_3/limtrp.F90	(revision 3516)
+++ /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_3/limtrp.F90	(revision 3517)
@@ -392,12 +392,10 @@
 
                   ! Ice salinity and age
-                  zsal = MAX( MIN( (rhoic-rhosn)/rhoic*sss_m(ji,jj)  , &
-                     zusvoic * zs0sm(ji,jj,jl) ), s_i_min ) * v_i(ji,jj,jl)
-                  IF ( ( num_sal .EQ. 2 ) .OR. ( num_sal .EQ. 4 ) ) & 
-                     smv_i(ji,jj,jl) = zindic*zsal + (1.0-zindic)*0.0
-
-                  zage = MAX( MIN( zbigval, zs0oi(ji,jj,jl) / & 
-                     MAX( a_i(ji,jj,jl), epsi16 )  ), 0.0 ) * a_i(ji,jj,jl)
-                  oa_i (ji,jj,jl)  = zindic*zage 
+                  zsal = MAX( MIN(  (rhoic-rhosn)/rhoic*sss_m(ji,jj) ,   &
+                     &              zusvoic * zs0sm(ji,jj,jl)         ) , s_i_min ) * v_i(ji,jj,jl)
+                  IF(  num_sal == 2  )   smv_i(ji,jj,jl) = zindic * zsal + (1.0-zindic) * 0._wp
+
+                  zage = MAX(  MIN( zbigval, zs0oi(ji,jj,jl) / MAX( a_i(ji,jj,jl), epsi16 ) ), 0._wp  ) * a_i(ji,jj,jl)
+                  oa_i (ji,jj,jl)  = zindic * zage 
 
                   ! Snow heat content
Index: /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_3/limupdate.F90
===================================================================
--- /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_3/limupdate.F90	(revision 3516)
+++ /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_3/limupdate.F90	(revision 3517)
@@ -190,24 +190,22 @@
 
                   ! is there any ice left ?
-                  zindic        = MAX( rzero, SIGN( rone, v_i(ji,jj,jl) - epsi10 ) ) 
+                  zindic = MAX( rzero , SIGN( rone, v_i(ji,jj,jl) - epsi10 ) ) 
                   !=1 if hi > 1e-3 and 0 if not
-                  zdvres        = MAX(0.0,-v_i(ji,jj,jl)) !residual volume if too much ice was molten
+                  zdvres = MAX( 0.0 , -v_i(ji,jj,jl) ) !residual volume if too much ice was molten
                   !this quantity is positive
-                  v_i(ji,jj,jl) = zindic*v_i(ji,jj,jl)    !ice volume cannot be negative
+                  v_i(ji,jj,jl) = zindic * v_i(ji,jj,jl)    !ice volume cannot be negative
                   !correct thermodynamic ablation
-                  d_v_i_thd(ji,jj,jl)  = zindic  *  d_v_i_thd(ji,jj,jl) + (1.0-zindic) * (-zviold - d_v_i_trp(ji,jj,jl)) 
+                  d_v_i_thd(ji,jj,jl) = zindic  *  d_v_i_thd(ji,jj,jl) + (1.0-zindic) * (-zviold - d_v_i_trp(ji,jj,jl)) 
                   ! THIS IS NEW
-                  d_a_i_thd(ji,jj,jl)  = zindic  *  d_a_i_thd(ji,jj,jl) + & 
-                     (1.0-zindic) * (-old_a_i(ji,jj,jl)) 
+                  d_a_i_thd(ji,jj,jl) = zindic  *  d_a_i_thd(ji,jj,jl) + (1.0-zindic) * (-old_a_i(ji,jj,jl)) 
 
                   !residual salt flux if ice is over-molten
-                  fsalt_res(ji,jj)  = fsalt_res(ji,jj) + ( sss_m(ji,jj) - sm_i(ji,jj,jl) ) * & 
-                     ( rhoic * zdvres / rdt_ice )
-                  !             fheat_res(ji,jj)  = fheat_res(ji,jj) + rhoic * lfus * zdvres / rdt_ice
+                  fsalt_res(ji,jj)  = fsalt_res(ji,jj) - sm_i(ji,jj,jl) * ( rhoic * zdvres * r1_rdtice )
+                  !             fheat_res(ji,jj)  = fheat_res(ji,jj) + rhoic * lfus * zdvres * r1_rdtice
 
                   ! is there any snow left ?
-                  zindsn        = MAX( rzero, SIGN( rone, v_s(ji,jj,jl) - epsi10 ) ) 
-                  zvsold        = v_s(ji,jj,jl)
-                  zdvres        = MAX(0.0,-v_s(ji,jj,jl)) !residual volume if too much ice was molten
+                  zindsn = MAX(  rzero, SIGN( rone , v_s(ji,jj,jl) - epsi10 )  ) 
+                  zvsold = v_s(ji,jj,jl)
+                  zdvres = MAX( 0.0 , -v_s(ji,jj,jl) )   !residual volume if too much ice was molten
                   !this quantity is positive
                   v_s(ji,jj,jl) = zindsn*v_s(ji,jj,jl)    !snow volume cannot be negative
@@ -215,10 +213,7 @@
                   d_v_s_thd(ji,jj,jl)  = zindsn  *  d_v_s_thd(ji,jj,jl) + & 
                      (1.0-zindsn) * (-zvsold - d_v_s_trp(ji,jj,jl)) 
-                  !unsure correction on salt flux.... maybe future will tell it was not that right
-
-                  !residual salt flux if snow is over-molten
-                  fsalt_res(ji,jj)  = fsalt_res(ji,jj) + sss_m(ji,jj) * ( rhosn * zdvres / rdt_ice )
-                  !this flux will be positive if snow was over-molten
-                  !             fheat_res(ji,jj)  = fheat_res(ji,jj) + rhosn * lfus * zdvres / rdt_ice
+
+                  !no salt flux when snow is over-molten
+                  !             fheat_res(ji,jj)  = fheat_res(ji,jj) + rhosn * lfus * zdvres * r1_rdtice
                ENDIF
             END DO !ji
@@ -306,5 +301,5 @@
       !--------------
 
-      IF(  num_sal == 2  .OR.  num_sal == 4  ) THEN      ! general case
+      IF(  num_sal == 2  ) THEN      ! Prognostic salinity [Sice=F(z,t)]
          !
          IF( ln_nicep ) THEN  
@@ -317,5 +312,5 @@
             WRITE(numout,*) ' v_s : ', v_s(jiindx, jjindx, 1:jpl)
          ENDIF
-
+         !
          smv_i(:,:,:) = smv_i(:,:,:) + d_smv_i_thd(:,:,:) + d_smv_i_trp(:,:,:)
          !
@@ -616,11 +611,10 @@
             DO ji = 1, jpi
                IF ( internal_melt(ji,jj,jl) == 1 ) THEN
-                  v_s(ji,jj,jl)   = 0.0
-                  e_s(ji,jj,1,jl) = 0.0
+                  v_s(ji,jj,jl)   = 0._wp
+                  e_s(ji,jj,1,jl) = 0._wp
                   !   ! release heat
-                  fheat_res(ji,jj) = fheat_res(ji,jj)  &
-                     + ze_s * v_s(ji,jj,jl) / rdt_ice
+                  fheat_res(ji,jj) = fheat_res(ji,jj) + ze_s  * v_s(ji,jj,jl) * r1_rdtice
                   ! release mass
-                  rdm_snw(ji,jj) =  rdm_snw(ji,jj) + rhosn * v_s(ji,jj,jl)
+                  rdm_snw  (ji,jj) = rdm_snw  (ji,jj) + rhosn * v_s(ji,jj,jl)
                ENDIF
             END DO
@@ -648,5 +642,5 @@
                !                ENDIF
                IF ((oa_i(ji,jj,jl)-1.0)*86400.0.gt.(rdt_ice*numit*a_i(ji,jj,jl))) THEN
-                  oa_i(ji,jj,jl) = rdt_ice*numit/86400.0*a_i(ji,jj,jl)
+                  oa_i(ji,jj,jl) = rdt_ice * numit / 86400.0 * a_i(ji,jj,jl)
                ENDIF
                oa_i(ji,jj,jl) = zindb*zindic*oa_i(ji,jj,jl)
@@ -657,5 +651,5 @@
                !             v_s(ji,jj,jl)  = MAX( zindb * v_s(ji,jj,jl), 0.0) 
                ! snow thickness cannot be smaller than 1e-6
-               v_s(ji,jj,jl)  = zindsn*v_s(ji,jj,jl)*zindb
+               v_s(ji,jj,jl)  = zindsn * v_s(ji,jj,jl) * zindb
                v_s(ji,jj,jl)  = v_s(ji,jj,jl) *  MAX( 0.0 , SIGN( 1.0 , v_s(ji,jj,jl) - epsi06 ) )
 
@@ -737,21 +731,18 @@
       !---------------------
 
-      IF ( ( num_sal .EQ. 2 ) .OR. ( num_sal .EQ. 4 ) ) THEN ! general case
-
+      IF(  num_sal == 2  ) THEN      ! Prognostic salinity [Sice=F(z,t)]
+         !
          DO jl = 1, jpl
             DO jk = 1, nlay_i
                DO jj = 1, jpj 
-                  DO ji = 1, jpi
-                     ! salinity stays in bounds
-                     smv_i(ji,jj,jl)  =  MAX(MIN((rhoic-rhosn)/rhoic*sss_m(ji,jj),smv_i(ji,jj,jl)), &
-                        0.1 * v_i(ji,jj,jl) )
+                  DO ji = 1, jpi           ! salinity stays in bounds
+                     smv_i(ji,jj,jl)  =  MAX(MIN((rhoic-rhosn)/rhoic*sss_m(ji,jj),smv_i(ji,jj,jl)), 0.1 * v_i(ji,jj,jl) )
                      i_ice_switch    =  1.0-MAX(0.0,SIGN(1.0,-v_i(ji,jj,jl)))
-                     smv_i(ji,jj,jl)  = i_ice_switch*smv_i(ji,jj,jl) + &
-                        0.1*(1.0-i_ice_switch)*v_i(ji,jj,jl)
+                     smv_i(ji,jj,jl)  = i_ice_switch*smv_i(ji,jj,jl) + 0.1*(1.0-i_ice_switch)*v_i(ji,jj,jl)
                   END DO ! ji
                END DO ! jj
             END DO !jk
          END DO !jl
-
+         !
       ENDIF
 
@@ -819,4 +810,5 @@
             ! 1) Count the number of existing categories
             DO jl  = 1, jpl
+!!cr : comment the second line of zindb definition, and use epsi04 in the 1st one
                zindb   =  MAX( rzero, SIGN( rone, v_i(ji,jj,jl) - epsi03 ) ) 
                zindb   =  MAX( rzero, SIGN( rone, v_i(ji,jj,jl) ) ) 
Index: /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_3/limvar.F90
===================================================================
--- /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_3/limvar.F90	(revision 3516)
+++ /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_3/limvar.F90	(revision 3517)
@@ -182,5 +182,5 @@
       END DO
 
-      IF(  num_sal == 2  .OR.  num_sal == 4  )THEN
+      IF(  num_sal == 2  )THEN
          DO jl = 1, jpl
             DO jj = 1, jpj
@@ -309,11 +309,10 @@
       ! Vertically constant, constant in time
       !---------------------------------------
-      IF( num_sal == 1 )   s_i(:,:,:,:) = bulk_sal
+      IF(  num_sal == 1  )   s_i(:,:,:,:) = bulk_sal
 
       !-----------------------------------
       ! Salinity profile, varying in time
       !-----------------------------------
-
-      IF(   num_sal == 2  .OR.   num_sal == 4   ) THEN
+      IF(  num_sal == 2  ) THEN
          !
          DO jk = 1, nlay_i
@@ -331,5 +330,5 @@
          dummy_fac0 = 1._wp / ( s_i_0 - s_i_1 )       ! Weighting factor between zs_zero and zs_inf
          dummy_fac1 = s_i_1 / ( s_i_1 - s_i_0 )
-
+         !
          zalpha(:,:,:) = 0._wp
          DO jl = 1, jpl
@@ -347,5 +346,5 @@
             END DO
          END DO
-
+         !
          dummy_fac = 1._wp / nlay_i                   ! Computation of the profile
          DO jl = 1, jpl
@@ -361,5 +360,5 @@
             END DO ! jk
          END DO ! jl
-
+         !
       ENDIF ! num_sal
 
@@ -368,5 +367,5 @@
       !-------------------------------------------------------
 
-      IF( num_sal == 3 ) THEN      ! Schwarzacher (1959) multiyear salinity profile (mean = 2.30)
+      IF(  num_sal == 3  ) THEN      ! Schwarzacher (1959) multiyear salinity profile (mean = 2.30)
          !
          sm_i(:,:,:) = 2.30_wp
@@ -380,5 +379,5 @@
             END DO
          END DO
-
+         !
       ENDIF ! num_sal
       !
@@ -447,5 +446,5 @@
       !------------------------------------------------------
 
-      IF(  num_sal == 2  .OR.  num_sal == 4  ) THEN
+      IF(  num_sal == 2  ) THEN
          !
          DO ji = kideb, kiut          ! Slope of the linear profile zs_zero
Index: /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_3/limwri_dimg.h90
===================================================================
--- /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_3/limwri_dimg.h90	(revision 3516)
+++ /branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_3/limwri_dimg.h90	(revision 3517)
@@ -111,5 +111,5 @@
          zcmo(ji,jj,13) = qns(ji,jj)
          ! See thersf for the coefficient
-         zcmo(ji,jj,14) = - sfx (ji,jj) * rday * ( sss_m(ji,jj) + epsi16 ) / soce
+         zcmo(ji,jj,14) = - sfx (ji,jj) * rday      ! converted in Kg/m2/day = mm/day
          zcmo(ji,jj,15) = utau_ice(ji,jj)
          zcmo(ji,jj,16) = vtau_ice(ji,jj)
@@ -154,5 +154,5 @@
                rcmoy(ji,jj,13) = qns(ji,jj)
                ! See thersf for the coefficient
-               rcmoy(ji,jj,14) = - sfx (ji,jj) * rday * ( sss_m(ji,jj) + epsi16 ) / soce
+               rcmoy(ji,jj,14) = - sfx (ji,jj) * rday      ! converted in mm/day
                rcmoy(ji,jj,15) = utau_ice(ji,jj)
                rcmoy(ji,jj,16) = vtau_ice(ji,jj)
